unit MatrixCalc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OpenML, HelpMatrixCalc;

type
  TFLSEinv = class(TForm)

    Label1: TLabel;
    BC: TButton;
    BH: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    RadioGroup1: TRadioGroup;
    RB_A: TRadioButton;
    RB_B: TRadioButton;
    RB_C: TRadioButton;
    LD: TLabel;
    MM: TButton;
    AM: TButton;
    xchAB: TButton;
    SM: TButton;
    xchAC: TButton;
    xchBC: TButton;
    Button1: TButton;
    MA: TMemo;
    MB: TMemo;
    MC: TMemo;
    E_C: TEdit;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    LT: TLabel;
    Button4: TButton;
    Button9: TButton;
    Button10: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BSClick(Sender: TObject);
    procedure RBGClick(Sender: TObject);
    procedure RBJClick(Sender: TObject);
    procedure XchPoint(const S: String; var S1: String);
    procedure ReadMx(TM: TMemo; var AX: TArray2;  var Er: Integer);
    procedure DeleteSpace(const S: String; var S1: String);
    procedure DeleteSpaceA(const S: String; var S1: String);
    procedure BHClick(Sender: TObject);
    procedure BCClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure MMClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure AMClick(Sender: TObject);
    procedure SMClick(Sender: TObject);
    procedure xchABClick(Sender: TObject);
    procedure xchACClick(Sender: TObject);
    procedure xchBCClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  FLSEinv: TFLSEinv;
  A: TArray2;
  B,R: TArrayF;
  MathLib: TMathLib;
  HelpLi: THelpLi;



implementation
{uses
UMHCFS; }
{$R *.dfm}


procedure TFLSEinv.AMClick(Sender: TObject);
label endp;
var
N,i,j,Er,L,M1,M2,M3,M4,M: Integer;
F,D: TFloatType;
AX,BX,EX: TArray2;
S: String;
begin

 ReadMX(MA,AX,Er);
 ReadMX(MB,BX,Er);


if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;




M1:=High(AX[0]); M2:=High(BX[0]);
M3:=High(AX);    M4:=High(BX);
if (M1 <> M2) or (M3 <> M4) then
begin
 MessageBeep(MB_ICONHAND);
 MessageDlg('Discrepancy of dimensions of matrixes',mtError,[mbOk],0);
 goto endp;
end;

MathLib.MatrixAdd(AX,BX,EX);

MC.Lines.Clear;

L:=Length(EX);
M:=Length(EX[0]);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to M - 1 do
    begin
      S:=S+FloatToStr(EX[i,j])+' ; ';
    end;
MC.Lines.Add(S);

end;


//LD.Caption:=FloatToStr(D);
endp:
end;



procedure TFLSEinv.BCClick(Sender: TObject);
begin
ModalResult := mrCancel;
end;

procedure TFLSEinv.BHClick(Sender: TObject);
begin
 //H_Sett:=Sett;
 HelpLi:=THelpLi.Create(FLSEinv);
 HelpLi.ShowModal;
 //HelpB.Init(Sett);
 //if SelMode.ShowModal = mrOk then

 //Sett:=H_Sett;
 HelpLi.Destroy;
end;



procedure TFLSEinv.BSClick(Sender: TObject);
label endp;
var
N,i,j,Er,L: Integer;
F,D: TFloatType;
AX,EX: TArray2;
BX: TArrayF;
S: String;
begin
if RB_A.Checked then
begin
 MA.Lines.Clear;
 ReadMX(MA,AX,Er);
end
else
if RB_B.Checked then
begin
 MB.Lines.Clear;
 ReadMX(MB,AX,Er);
end
else
if RB_C.Checked then
begin
 MC.Lines.Clear;
 ReadMX(MC,AX,Er);
end;

if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;


MathLib.MatrixInvertDet(AX,EX,D);

L:=Length(EX);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to L - 1 do
    begin
      S:=S+FloatToStr(EX[i,j])+' ; ';
    end;
    MB.Lines.Add(S);
end;


LD.Caption:=FloatToStr(D);

endp:
end;




procedure TFLSEinv.FormCreate(Sender: TObject);
begin
 MathLib.SetMode(ml_LSE_Method,ml_Gauss);
 //MathLib.SetMode(ml_LSE_Method,ml_Jordan);
end;



procedure TFLSEinv.FormDestroy(Sender: TObject);
begin
 //Clp.Destroy;
end;

procedure TFLSEinv.MMClick(Sender: TObject);
label endp;
var
N,i,j,Er,L,M1,M2,M: Integer;
F,D: TFloatType;
AX,BX,EX: TArray2;
S: String;
begin

 ReadMX(MA,AX,Er);
 ReadMX(MB,BX,Er);


if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;




M1:=High(AX[0]); M2:=High(BX);
if M1 <> M2 then
begin
 MessageBeep(MB_ICONHAND);
 MessageDlg('Discrepancy of dimensions of matrixes',mtError,[mbOk],0);
 goto endp;
end;

MathLib.MatrixMul(AX,BX,EX);

MC.Lines.Clear;

L:=Length(EX);
M:=Length(EX[0]);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to M - 1 do
    begin
      S:=S+FloatToStr(EX[i,j])+' ; ';
    end;
MC.Lines.Add(S);

end;


//LD.Caption:=FloatToStr(D);
endp:
end;

procedure TFLSEinv.RBGClick(Sender: TObject);
begin
 MathLib.SetMode(ml_LSE_Method,ml_Gauss);
end;

procedure TFLSEinv.RBJClick(Sender: TObject);
begin
MathLib.SetMode(ml_LSE_Method,ml_Jordan);
end;



procedure TFLSEinv.XchPoint(const S: String; var S1: String);
var i: Integer;
S2: String;
begin
i:=Length(S);
S2:=Copy(S,1,Length(S));
 while i >= 1 do
 begin
   if (S2[i] = '.') then
   begin
    Delete(S2,i,1);   Insert(',',S2,i);
   end;
   dec(i);
 end;

S1:=Copy(S2,1,Length(S2));
end;



procedure TFLSEinv.ReadMx(TM: TMemo; var AX: TArray2;  var Er: Integer);
label endp;
label 1;
var
i,j,Str,Col,p,k: Integer;
SX: TArrayF;
F: TFloatType;
S,S1,S2: String;
BH: Boolean;
m: Integer;
begin
Str:=0; Col:=0; Er:=0; k:=0;
for i := 0 to TM.Lines.Count do
begin
 p:=1;  SetLength(SX,0);
 DeleteSpace(TM.Lines[i],S);
 if S = '' then goto 1;

 for j := 1 to Length(TM.Lines[i]) do
 begin
   BH:=True;
   if (TM.Lines[i][j] = ' ') or  (TM.Lines[i][j] = ';') or  (TM.Lines[i][j] = '=') or (j = Length(TM.Lines[i])) then
   begin
     S:=Copy(TM.Lines[i],p,j-p+1);
     DeleteSpaceA(S,S2);
     XchPoint(S2,S2);
     try
       F:=StrToFloat(S2);
     except
       BH:=False;
     end;
     if BH = True then
     begin
      p:=j;
      SetLength(SX,Length(SX)+1);
      SX[High(SX)]:=F;
     end;
   end;
 end;

 if Length(SX) <> 0  then
 begin
  inc(k);
  SetLength(AX,k,Length(SX));
  for m := 0 to Length(SX) - 1 do
    begin
      AX[k-1,m]:=SX[m];
    end;
  if (k-1 > 0) and (Length(SX) <> Col) then
  begin
    Er:=1;
    goto endp;
  end;
 end;

 Col:=Length(SX);
1:
end;

if Length(AX) = 0 then  Er:=1 else
//if Length(AX) <> Length(AX[0]) then  Er:=1 else
//if Length(AX[0]) = 0 then  Er:=1;

//////////
{for I := 0 to Length(SX) - 1 do
  begin
    MR.Lines[i]:=FloatToStr(SX[i]);
  end;
}
endp:
end;







procedure TFLSEinv.DeleteSpace(const S: String; var S1: String);
var i: Integer;
S2: String;
begin
i:=Length(S);
S2:=Copy(S,1,Length(S));
 while i >= 1 do
 begin
   if (S2[i] = ' ') then
   begin
    Delete(S2,i,1);
   end;
  dec(i);
 end;

S1:=Copy(S2,1,Length(S2));
end;





procedure TFLSEinv.DeleteSpaceA(const S: String; var S1: String);
var i: Integer;
S2: String;
begin
i:=Length(S);
S2:=Copy(S,1,Length(S));
 while i >= 1 do
 begin
   if (S2[i] = ' ') or  (S2[i] = ';') or (S2[i] = '=')then
   begin
    Delete(S2,i,1);
   end;
  dec(i);
 end;

S1:=Copy(S2,1,Length(S2));
end;



procedure TFLSEinv.Button10Click(Sender: TObject);
label endp;
var
N,i,j,Er,L: Integer;
F,D: TFloatType;
AX,BX: TArray2;
VR,VB: TArrayF;
begin
MC.Lines.Clear;

ReadMX(MA,AX,Er);
ReadMX(MB,BX,Er);
if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;

L:=Length(BX);
SetLength(VB,L);
for i:=0 to L - 1 do
  begin
    VB[i]:=BX[i,0];
  end;
MathLib.LSE(AX,VB,VR,D);

for i:=0 to Length(VR)-1 do
  begin
    MC.Lines.Add(FloatToStr(VR[i]))
  end;

//L1.Caption:=FloatToStr(D);

endp:
end;



procedure TFLSEinv.Button1Click(Sender: TObject);
begin
 MC.SelectAll;
 MC.CopyToClipboard;
end;



procedure TFLSEinv.Button2Click(Sender: TObject);
label endp;
var
N,i,j,Er,L,M: Integer;
F,D: TFloatType;
AX,EX: TArray2;
BX: TArrayF;
S: String;
begin
if RB_A.Checked then
begin
 ReadMX(MA,AX,Er);
 MA.Lines.Clear;
end
else
if RB_B.Checked then
begin
 ReadMX(MB,AX,Er);
 MB.Lines.Clear;
end
else
if RB_C.Checked then
begin
 ReadMX(MC,AX,Er);
 MC.Lines.Clear;
end;

if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;


F:=StrToFloat(E_C.Text);
MathLib.MatrixMulConst(AX,F);





L:=Length(AX); M:=Length(AX[0]);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to M - 1 do
    begin
      S:=S+FloatToStr(AX[i,j])+' ; ';
    end;


    if RB_A.Checked then  MA.Lines.Add(S) else
    if RB_B.Checked then  MB.Lines.Add(S) else
    if RB_C.Checked then  MC.Lines.Add(S);

end;


//LD.Caption:=FloatToStr(D);
endp:
end;



procedure TFLSEinv.Button5Click(Sender: TObject);
label endp;
var
D: extended;
AX: TArray2;
Er: Integer;
begin
 if RB_A.Checked then
begin
 ReadMX(MA,AX,Er);
 if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;
 MathLib.MatrixDeterminant(AX,D);
end
else
if RB_B.Checked then
begin
 ReadMX(MB,AX,Er);
 if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;
 MathLib.MatrixDeterminant(AX,D);
end
else
if RB_C.Checked then
begin
 ReadMX(MC,AX,Er);
 if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;
 MathLib.MatrixDeterminant(AX,D);
end;
 LD.Caption:=FloatToStr(D);

 endp:
end;



procedure TFLSEinv.Button6Click(Sender: TObject);
label endp;
var
N,i,j,Er,L,M: Integer;
F,D: TFloatType;
AX,EX: TArray2;
BX: TArrayF;
S: String;
begin
if RB_A.Checked then
begin
 ReadMX(MA,AX,Er);
 MA.Lines.Clear;
end
else
if RB_B.Checked then
begin
 ReadMX(MB,AX,Er);
 MB.Lines.Clear;
end
else
if RB_C.Checked then
begin
 ReadMX(MC,AX,Er);
 MC.Lines.Clear;
end;

if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;


MathLib.MatrixTransposeA(AX,EX);





L:=Length(EX); M:=Length(EX[0]);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to M - 1 do
    begin
      S:=S+FloatToStr(EX[i,j])+' ; ';
    end;


    if RB_A.Checked then  MA.Lines.Add(S) else
    if RB_B.Checked then  MB.Lines.Add(S) else
    if RB_C.Checked then  MC.Lines.Add(S);

end;


//LD.Caption:=FloatToStr(D);
endp:
end;



procedure TFLSEinv.Button7Click(Sender: TObject);
label endp;
var
N,i,j,Er,L: Integer;
F,D: TFloatType;
AX,EX: TArray2;
BX: TArrayF;
S: String;
begin
if RB_A.Checked then
begin
 ReadMX(MA,AX,Er);
 MA.Lines.Clear;
end
else
if RB_B.Checked then
begin
 ReadMX(MB,AX,Er);
 MB.Lines.Clear;
end
else
if RB_C.Checked then
begin
 ReadMX(MC,AX,Er);
 MC.Lines.Clear;
end;

if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;


MathLib.MatrixInvertDet(AX,EX,D);





L:=Length(EX);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to L - 1 do
    begin
      S:=S+FloatToStr(EX[i,j])+' ; ';
    end;


    if RB_A.Checked then  MA.Lines.Add(S) else
    if RB_B.Checked then  MB.Lines.Add(S) else
    if RB_C.Checked then  MC.Lines.Add(S);

end;


//LD.Caption:=FloatToStr(D);
endp:
end;



procedure TFLSEinv.Button8Click(Sender: TObject);
label endp;
var
N,i,j,Er,L,M1,M2: Integer;
F,D: TFloatType;
AX,BX,EX: TArray2;
//BX: TArrayF;
S: String;
begin
F:=StrToFloat(E_C.Text);
if F <> Trunc(F) then
begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Only integer degree',mtError,[mbOk],0);
     goto endp;
end;

if RB_A.Checked then
begin
 ReadMX(MA,AX,Er);
end
else
if RB_B.Checked then
begin
 ReadMX(MB,AX,Er);
end
else
if RB_C.Checked then
begin
 ReadMX(MC,AX,Er);
end;

if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;

M1:=High(AX[0]); M2:=High(AX);
if M1 <> M2 then
begin
 MessageBeep(MB_ICONHAND);
 MessageDlg('Discrepancy of dimensions of matrixes',mtError,[mbOk],0);
 goto endp;
end;



N:=abs(Trunc(F));
L:=Length(AX);
if N = 0 then
begin
 MathLib.GetMatrixE(1,L,BX);
end
else
if N = 1 then
begin
  BX:=Copy(AX);
end
else
if N >= 2 then
begin
 MathLib.MatrixMul(AX,AX,BX);
 for I := 1 to N - 2 do
   MathLib.MatrixMul(AX,BX,BX);
end;

if F < 0  then
 MathLib.MatrixInvert(BX,BX);





 if RB_A.Checked then  begin MA.Lines.Clear;    end  else
    if RB_B.Checked then  begin MB.Lines.Clear;   end  else
    if RB_C.Checked then  begin MC.Lines.Clear;    end;


L:=Length(BX);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to L - 1 do
    begin
      S:=S+FloatToStr(BX[i,j])+' ; ';
    end;


    if RB_A.Checked then  begin  MA.Lines.Add(S)   end  else
    if RB_B.Checked then  begin  MB.Lines.Add(S);  end  else
    if RB_C.Checked then  begin  MC.Lines.Add(S);  end;

end;


//LD.Caption:=FloatToStr(D);
endp:
end;



procedure TFLSEinv.Button3Click(Sender: TObject);
label endp;
var
D: extended;
AX: TArray2;
Er: Integer;
begin
 if RB_A.Checked then
begin
 ReadMX(MA,AX,Er);
end
else
if RB_B.Checked then
begin
 ReadMX(MB,AX,Er);
end
else
if RB_C.Checked then
begin
 ReadMX(MC,AX,Er);
end;
 if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;
 D:=MathLib.MatrixTrace(AX);
 LT.Caption:=FloatToStr(D);

 endp:
end;


procedure TFLSEinv.Button4Click(Sender: TObject);
label endp;
var
N,i,j,Er,L,M1,M2,M3,M4,M: Integer;
F,D: TFloatType;
AX,BX,EX: TArray2;
S: String;
begin

 ReadMX(MA,AX,Er);
 if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;

 MathLib.GetMatrixLR(AX,BX,EX);

MB.Lines.Clear;
MC.Lines.Clear;

L:=Length(BX);
M:=Length(BX[0]);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to M - 1 do
    begin
      S:=S+FloatToStr(BX[i,j])+' ; ';
    end;
MB.Lines.Add(S);
end;

L:=Length(EX);
M:=Length(EX[0]);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to M - 1 do
    begin
      S:=S+FloatToStr(EX[i,j])+' ; ';
    end;
MC.Lines.Add(S);
end;

endp:
end;




procedure TFLSEinv.SMClick(Sender: TObject);
label endp;
var
N,i,j,Er,L,M1,M2,M3,M4,M: Integer;
F,D: TFloatType;
AX,BX,EX: TArray2;
S: String;
begin

 ReadMX(MA,AX,Er);
 ReadMX(MB,BX,Er);


if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;




M1:=High(AX[0]); M2:=High(BX[0]);
M3:=High(AX);    M4:=High(BX);
if (M1 <> M2) or (M3 <> M4) then
begin
 MessageBeep(MB_ICONHAND);
 MessageDlg('Discrepancy of dimensions of matrixes',mtError,[mbOk],0);
 goto endp;
end;

MathLib.MatrixSub(AX,BX,EX);

MC.Lines.Clear;

L:=Length(EX);
M:=Length(EX[0]);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to M - 1 do
    begin
      S:=S+FloatToStr(EX[i,j])+' ; ';
    end;
MC.Lines.Add(S);

end;


//LD.Caption:=FloatToStr(D);
endp:
end;

procedure TFLSEinv.xchABClick(Sender: TObject);
var
MA1,MB1: array of String;
i,j,AL,BL: Integer;
begin
AL:=MA.Lines.Count;
BL:=MB.Lines.Count;
SetLength(MA1,MA.Lines.Count+1);
SetLength(MB1,MB.Lines.Count+1);

for i := 0 to MA.Lines.Count do
begin
 MA1[i]:=Copy(MA.Lines[i],1,Length(MA.Lines[i]));
end;

for i := 0 to MB.Lines.Count do
begin
 MB1[i]:=Copy(MB.Lines[i],1,Length(MB.Lines[i]));
end;



MA.Lines.Clear;
MB.Lines.Clear;

for i := 0 to AL do
begin
 MB.Lines.Add(MA1[i]);
end;

for i := 0 to BL do
begin
 MA.Lines.Add(MB1[i]);
end;

MA1:=nil;
MB1:=nil;

end;



procedure TFLSEinv.xchACClick(Sender: TObject);
var
MA1,MC1: array of String;
i,j,AL,CL: Integer;
begin
AL:=MA.Lines.Count;
CL:=MC.Lines.Count;
SetLength(MA1,MA.Lines.Count+1);
SetLength(MC1,MC.Lines.Count+1);

for i := 0 to MA.Lines.Count do
begin
 MA1[i]:=Copy(MA.Lines[i],1,Length(MA.Lines[i]));
end;

for i := 0 to MC.Lines.Count do
begin
 MC1[i]:=Copy(MC.Lines[i],1,Length(MC.Lines[i]));
end;



MA.Lines.Clear;
MC.Lines.Clear;

for i := 0 to AL do
begin
 MC.Lines.Add(MA1[i]);
end;

for i := 0 to CL do
begin
 MA.Lines.Add(MC1[i]);
end;

MA1:=nil;
MC1:=nil;

end;



procedure TFLSEinv.xchBCClick(Sender: TObject);
var
MB1,MC1: array of String;
i,j,BL,CL: Integer;
begin
BL:=MB.Lines.Count;
CL:=MC.Lines.Count;
SetLength(MB1,MB.Lines.Count+1);
SetLength(MC1,MC.Lines.Count+1);

for i := 0 to MB.Lines.Count do
begin
 MB1[i]:=Copy(MB.Lines[i],1,Length(MB.Lines[i]));
end;

for i := 0 to MC.Lines.Count do
begin
 MC1[i]:=Copy(MC.Lines[i],1,Length(MC.Lines[i]));
end;



MB.Lines.Clear;
MC.Lines.Clear;

for i := 0 to BL do
begin
 MC.Lines.Add(MB1[i]);
end;

for i := 0 to CL do
begin
 MB.Lines.Add(MC1[i]);
end;

MB1:=nil;
MC1:=nil;

end;




procedure TFLSEinv.Button9Click(Sender: TObject);
label endp;
var
N,i,j,Er,L,M1,M2,M3,M4,M: Integer;
F,D: TFloatType;
AX,BX,EX: TArray2;
S: String;
begin

 ReadMX(MA,AX,Er);
 ReadMX(MB,BX,Er);


if Er = 1 then
   begin
     MessageBeep(MB_ICONHAND);
     MessageDlg('Error at input of matrix',mtError,[mbOk],0);
     goto endp;
   end;




M1:=High(AX[0]); M2:=High(BX[0]);
M3:=High(AX);    M4:=High(BX);
if (M1 <> M2) or (M3 <> M4) then
begin
 MessageBeep(MB_ICONHAND);
 MessageDlg('Discrepancy of dimensions of matrixes',mtError,[mbOk],0);
 goto endp;
end;

F:=StrToFloat(E_C.Text);

MathLib.MatrixMulConstAdd(AX,BX,f,EX);

MC.Lines.Clear;

L:=Length(EX);
M:=Length(EX[0]);
for I := 0 to L - 1 do
begin
 S:='';
  for J := 0 to M - 1 do
    begin
      S:=S+FloatToStr(EX[i,j])+' ; ';
    end;
MC.Lines.Add(S);

end;


//LD.Caption:=FloatToStr(D);
endp:
end;







end.
